//
//  LazarusCalculator.swift
//  psychology_ios_native
//
//  Created by Eldar Goloviznin on 23/10/2019.
//  Copyright © 2019 Psychology. All rights reserved.
//

import Foundation
import XlsxReaderWriter

private enum Lazarus: String, CaseIterable {
    case confront
    case distant
    case selfControl
    case socSupport
    case responsibility
    case running
    case problemSolve
    case positiveOverrate
    
    var title: String {
        switch self {
        case .confront: return "Конфронтационный копинг"
        case .distant: return "Дистанцирование"
        case .positiveOverrate: return "Положительная переоценка"
        case .problemSolve: return "Планирование решения проблемы"
        case .responsibility: return "Принятие ответственности"
        case .running: return "Бегство-избегание"
        case .selfControl: return "Самоконтроль"
        case .socSupport: return "Поиск социальной поддержки"
        }
    }
}

struct LazarusCalculator: TestCalculator {
    
    let test: Test
    let info: InfoAboutRealm
    
    private let keysMap: [Lazarus: [Int]] = [
        .confront: [2, 3, 13, 21, 26, 37],
        .distant: [8, 9, 11, 16, 32, 35],
        .positiveOverrate: [15, 18, 23, 28, 29, 45, 48],
        .problemSolve: [1, 20, 30, 39, 40, 43],
        .responsibility: [5, 19, 22, 42],
        .running: [7, 12, 25, 31, 38, 41, 46, 47],
        .selfControl: [6, 10, 27, 34, 44, 49, 50],
        .socSupport: [4, 14, 17, 24, 33, 36]
    ]
    
    private let advices: [Lazarus: [String]] = [
        .confront: [
            "Вы склонны избегать конфликтов и не всегда отстаиваете собственные интересы.",
            "Вы умеренно используете такую стратегию преодоления трудностей, как конфронтация. Она обеспечивает вашу способность сопротивляться трудностям, энергичность и предприимчивость при разрешении проблемных ситуаций, умение отстаивать собственные интересы, справляться с тревогой в стрессогенных условиях.",
            "В проблемных ситуациях вы можете становиться импульсивным в поведении. Порой с элементами враждебности и конфликтности. Преобладание стратегии конфронтации повышает враждебность, создает трудности планирования действий, прогнозирования их результата, коррекции стратегии поведения, неоправданное упорство. Действия по преодолению стресса при этом теряют свою целенаправленность и становятся преимущественно результатом разрядки эмоционального напряжения."
        ],
        .distant: [
            "Вы редко отстраняетесь от собственных проблем и негативных переживаний. Это может приводить к тому, что вы воспринимаете происходящее близко к сердцу.",
            "Стратегия дистанцирования помогает вам снижать значимость ситуации и степень эмоциональной вовлеченности в нее. Для этого вы можете пользоваться приемами поиска рационального зерна, переключения внимания, отстранения, юмора, обесценивания и т.п.\nЭто позволяет вам предотвращать возникновение интенсивных эмоциональных реакций на стресс.",
            "Вы очень часто используете дистанцирование от стрессовых ситуаций. Однако при этом возрастает вероятность обесценивания собственных переживаний, недооценка значимости и возможностей действенного преодоления проблемных ситуаций."
        ],
        .positiveOverrate: [
            "Неумение видеть положительные стороны в проблемах может приводить к тому, что вы воспринимаете тяжелые ситуации как безвыходные или катастрофичные. Между тем, многие проблемы дают нам возможность личностного роста.",
            "Вы  умеете преодолевать негативные переживания за счет положительного переосмысления. Рассматриваете неприятности как стимул для личностного роста.",
            "Вы легко находите позитивные стороны даже в проблемах. Однако чрезмерное использование данной тактики может привести к недооценке возможностей действенного разрешения и затягиванию проблемных ситуаций."
        ],
        .problemSolve: [
            "Вы недостаточно планируете решение проблем. Возможно, склонны полагаться на «авось», интуицию или спонтанное развитие событий.",
            "Вы умеете справляться со сложными ситуациями путем целенаправленного анализа ситуации и возможных вариантов поведения, выработки стратегии разрешения проблемы, планирования собственных действий с учетом объективных условий, прошлого опыта и имеющихся ресурсов. Эта стратегия позволяет вам планомерно разрешать проблемные ситуации.",
            "Вы склонны чрезмерно планировать решение проблем. Это может приводить к излишнему обдумыванию, попытке отдалиться от своих эмоций, задавить интуицию и спонтанность в поведении."
        ],
        .responsibility: [
            "Вы склонны недооценивать собственную роль в возникновении актуальных трудностей. В связи с этим может рождаться ощущение, что вы не можете справиться с ситуацией.",
            "Вы в достаточной степени признаете свою роль в возникновении проблемы и принимаете ответственность за ее решение. Порой вы склонны к самокритике и самообвинению. Вы стремитесь к пониманию зависимости между собственными действиями и их последствиями, готовы анализировать свое поведение, искать причины актуальных трудностей в личных недостатках и ошибках.",
            "Вы склонны излишне брать ответственность на себя. Это может приводить к неоправданной самокритике, переживанию чувства вины и неудовлетворенности собой. Подобная стратегия является фактором риска развития депрессивных состояний."
        ],
        .running: [
            "Вы редко избегаете трудностей.",
            "Периодически вы используете стратегию избегания трудностей. Стратегия бегства-избегания предполагает попытки преодоления личностью негативных переживаний в связи с трудностями за счет реагирования по типу уклонения: отрицания проблемы, фантазирования, неоправданных ожиданий, отвлечения и т.п.\nВ основном эта стратегия относится к неадаптивным, но она может приносить пользу при острых стрессогенных ситуациях за счет снижения эмоционального дискомфорта.",
            "Вы склонны избегать сложных ситуаций. Зачастую это сопровождается отрицанием либо полным игнорированием проблемы, уклонением от ответственности. Вы предпочитаете не предпринимать действия по разрешению возникших трудностей. Что часто проявляется пассивностью, нетерпением, вспышками раздражения, погружением в фантазии, перееданием или употребление алкоголя, с целью снижения мучительного эмоционального напряжения."
        ],
        .selfControl: [
            "Вы редко подавляете или сдерживаете свои эмоции в проблемных ситуациях.",
            "Вы умеете целенаправленно подавлять и сдерживать эмоции, стремитесь к самообладанию. Это позволяет вам избегать импульсивных поступков, рационально выбирать стратегию поведения. Контролировать себя.",
            "Вы отчетливо предпочитаете стратегию самоконтроля, подавляете свои эмоции. Стремитесь скрывать от окружающих свои переживания и побуждения в связи с проблемной ситуацией. Часто такое поведение свидетельствует о боязни самораскрытия, чрезмерной требовательности к себе, приводящей к сверхконтролю поведения. Такая тактика может способствовать появлению психосоматических расстройств."
        ],
        .socSupport: [
            "Вы не склонны обращаться за помощью к окружающим в трудных ситуациях.",
            "Стратегия поиска социальной поддержки помогает вам решать проблемы за счет привлечения внешних (социальных) ресурсов, поиска информационной, эмоциональной и действенной поддержки. Вы ориентированы на взаимодействие с другими людьми, ожидаете внимания, совета, сочувствия.",
            "В трудных ситуациях вы часто обращаетесь за рекомендациями к экспертам и знакомым, владеющим с вашей точки зрения необходимыми знаниями. В связи с этим возникает потребность в эмоциональной поддержке, появляется стремление быть выслушанным, получить принятие, разделить с кем-либо свои переживания. При поиске преимущественно действенной поддержки ведущей является потребность в помощи конкретными действиями. Выраженный поиск социальной поддержки может формировать зависимость или чрезмерные ожидания по отношению к окружающим."
        ]
    ]
    
    func calculate(summary: TestAnswerSummary) -> TestResult {
        let answers = summary.answers
        
        var results: [ResultDescription] = []
        var pairs: [Pair] = []
        let arr = [
            "Лазарус конфронтация",
            "Лазарус дистанцирование",
            "Лазарус самоконтроль",
            "Лазарус поиск соц поддержки",
            "Лазарус ответственность",
            "Лазарус бегство",
            "Лазарус планирование",
            "Лазарус положительная переоценка"
        ]
        for (index, category) in Lazarus.allCases.enumerated() {
            let points = getPoints(category: category, answers: answers)
            pairs.append(Pair(key: arr[index], value: points))
            let index: Int
            switch points {
            case ...39: index = 0
            case 40...60: index = 1
            default: index = 2
            }
            guard let categoryAdvice = advices[category] else { continue }
            results.append(ResultDescription(title: "\(category.title) (\(points))", advice: categoryAdvice[index]))
        }
        
        return TestResult(test: test, results: results, res: Res(title: "Лазарус", pairs: pairs))
    }
    
}

private extension LazarusCalculator {
    
    func getPoints(category: Lazarus, answers: [TestAnswer]) -> Int {
        guard let path = Bundle.main.path(forResource: category.rawValue, ofType: "xlsx") else { return 0 }
        guard let workSheet = BRAOfficeDocumentPackage.open(path)?.workbook.worksheets.first as? BRAWorksheet else { return 0 }
        
        guard let keys = keysMap[category] else { return 0 }
        
        var rawPoints = 0
        for key in keys {
            rawPoints += answers[key - 1].weight
        }
        
        let sexIndex = info.sex == .man ? 0 : 1
        let ageIndex: Int
        switch info.age {
        case ...20: ageIndex = 0
        case 21...30: ageIndex = 1
        case 31...45: ageIndex = 2
        default: ageIndex = 3
        }
        
        let index = ageIndex + sexIndex * 4
        
        let columns = "ABCDEFGH"
        
        let points = workSheet.cell(forCellReference: "\(columns[columns.index(columns.startIndex, offsetBy: index)])\(rawPoints + 1)")?.integerValue()
        
        return points ?? 0
    }
    
}
